Unit Fonts_p;
{$R-}

InterFace
Const F_None=0;
      F_Bold=1;
      F_Thick=1;
      F_Italic=2;
      F_UndLined=4;

Function LoadFont(FontName:String;Convert:Boolean):Boolean;
Procedure ReleaseFont;
Procedure OutChar(c:Char);
Procedure OutString(s:String);
Procedure OutStringXY(x,y:Integer;s:String);
Procedure OutStringC(x1,x2,y:Integer;s:String);{Center between x1 & x2 }
Function StrWidth(s:String):Word;
Function FontHeight:Byte;
Procedure SetTextAttr(Attr,ISh:Byte);

Implementation
Uses Tools,Paper;
Type Bytes  = Array[0..$60] of Byte;
     pBytes = ^Bytes;

Var FontLen:Longint; {The length of font file}
    Dat:pBytes; {The Font File}
    FirstSymbol,LastSymbol,Height,TextAttr,IShift:Byte;
    Convert_On:Boolean;

Function Min(x,y:Byte):Byte;
Begin
     If x<y then Min:=x else Min:=y;
End;

Procedure Convert(Var c:Char);
Var o:Byte;
Begin
  If Convert_On then Begin
    o:=Ord(c);
    Case o of
       ord('')..ord(''): c:=Char(o+$40);
       ord('')..ord(''): c:=Char(o+$10);
       ord('')+1..ord('')-1: c:=Char(o-$30);
       $F0..$FF: c:=Char(o-$40);
    End;
  End;
End;

Procedure ReleaseFont;
Begin
     If Dat<>nil then Begin
        FreeMem(Dat,FontLen);
        Dat:=nil;
     End;
End;

Function LoadFont(FontName:String;Convert:Boolean):Boolean;
Var f:File;
Begin
     ReleaseFont;
     If Exist(FontName) then Begin
        Assign(f,FontName);
        ReSet(f,1);
        FontLen:=FileSize(f);
        If MaxAvail>FontLen then Begin
           GetMem(Dat,FontLen);
           BlockRead(f,Dat^,FontLen);
           Close(f);
           FirstSymbol:=Dat^[$5F];
           LastSymbol:=Dat^[$60];
           Height:=Dat^[$58];
           LoadFont:=True;
           Convert_On:=Convert;
        End else LoadFont:=False;
     End else LoadFont:=False;
End;

Function CharWidth(c:Char):Byte;
Begin
     If (Ord(c)<FirstSymbol)or(Ord(c)>LastSymbol) then c:=' ';
     CharWidth:=Dat^[$76+4*(Ord(c)-FirstSymbol)]
End;
Function CharAddr(c:Char):Word;
Begin
     If (Ord(c)<FirstSymbol)or(Ord(c)>LastSymbol) then c:=' ';
     CharAddr:= Dat^[$78+4*(Ord(c)-FirstSymbol)]+
                Dat^[$79+4*(Ord(c)-FirstSymbol)]*256;
End;

Procedure OutChar(c:Char);
Var x,y,ttm:Integer;
    Cha:Word;{adr of char}
    i,j,k,l,Wdth:Byte;
    col:Byte;
    AItalic:Boolean;
Begin
     Convert(c);
     x:=GetX;y:=GetY;col:=GetColor;
     Cha:=CharAddr(c);
     Wdth:=CharWidth(c)-1;
     AItalic:=(TextAttr and F_Italic)=F_Italic;
     If (TextAttr and F_Bold)=0 then Begin
       For i:=0 to (Wdth div 8) do Begin
         For j:=0 to Min(7,Wdth-i*8) do
             For k:=0 to Height-1 do Begin
                 l:=$80 shr j;
                 If ((Dat^[Cha+k+i*Height])and l)=l then
                 If AItalic then PutPixel(x+i*8+j+(Height-1-k) div IShift,y+k,col)
                            else PutPixel(x+i*8+j,y+k,col);
             End;
       End;
       MoveRel(Wdth+1,0);
     End else Begin
       For i:=0 to (Wdth div 8) do Begin
         For j:=0 to Min(7,Wdth-i*8) do
             For k:=0 to Height-1 do Begin
                 l:=$80 shr j;
                 If ((Dat^[Cha+k+i*Height])and l)=l then
                 If AItalic then Begin ttm:=x+i*8+j+(Height-1-k) div IShift; Line(ttm,y+k,ttm+1,y+k); End
                            else Line(x+i*8+j,y+k,x+i*8+j+1,y+k);
             End;
       End;
       MoveRel(Wdth+2,0);
     End;

End;

Procedure OutString(s:String);
Var i:Byte;
Begin
  If Length(s)>0 then
     For i:=1 to Length(s) do OutChar(s[i]);
End;

Procedure OutStringXY(x,y:Integer;s:String);
Begin
     MoveTo(x,y);
     OutString(s);
End;

Function StrWidth(s:String):Word;
Var i:Byte;sum:Word;
Begin
  Sum:=0;
  If Length(s)>0 then
     For i:=1 to Length(s) do Begin
         Convert(s[i]);
         Sum:=Sum+CharWidth(s[i]);
     End;
  StrWidth:=Sum;
End;

Procedure OutStringC(x1,x2,y:Integer;s:String);{Center between x1 & x2}
Var lll:Word;
Begin
     lll:=StrWidth(s);
     OutStringXY(x1+((x2-x1-lll) div 2),y,s);
End;

Function FontHeight:Byte;
Begin
     FontHeight:=Height;
End;

Procedure SetTextAttr(Attr,ISh:Byte);
Begin
     TextAttr:=Attr;
     If ISh=0 then IShift:=1
              else IShift:=ISh;
End;

Begin
     Dat:=Nil;
     SetTextAttr(0,3);
End.